'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
        var declaration = path.node.declaration;


        if (!t.isCallExpression(declaration)) {
          return;
        }

        var callee = declaration.callee,
            componentNode = declaration.arguments;


        if (!t.isCallExpression(callee)) {
          return;
        }

        var compose = callee.callee,
            args = callee.arguments;

        args.reverse();

        var lastID = path.scope.generateUidIdentifier('decomposed');
        var last = t.callExpression(args[0], componentNode);

        var nodes = [];

        for (var i = 1; i < args.length; i++) {
          var declarator = t.variableDeclarator(lastID, last);
          var _declaration = t.variableDeclaration('const', [declarator]);
          nodes.push(_declaration);

          last = t.callExpression(args[i], [lastID]);
          lastID = path.scope.generateUidIdentifier('decomposed');
        }

        var finalID = lastID;
        var finalDeclarator = t.variableDeclarator(finalID, last);
        var finalDeclaration = t.variableDeclaration('const', [finalDeclarator]);
        nodes.push(finalDeclaration);

        nodes.push(t.exportDefaultDeclaration(finalID));

        path.replaceWithMultiple(nodes);
      }
    }
  };
};